# $Id: kdemultimedia.spec,v 1.49 2006/04/09 20:12:40 rexdieter Exp $

# NOTE: can only build *one* of the following at a time
#  core: kdemultidia/kdemultimedia-devel
#  extras: kdemultimedia-extras
#  nonfree: kdemultimedia-nonfree
#define core 1
%define extras 1
#define nonfree 1

# enable pkg/filelist debugging -- Rex
#define debug 1

%if "%{?core}" == "1"
%define patched -patched
%endif

%if "%{?extras}" == "1"
%define patched -patched
%define _with_akode --with-akode
# to make sure no nonfree bits get included
BuildConflicts: akode-extras
# debugging: to make sure no extras bits (accidentally) get excluded
%{?debug:BuildConflicts: kdemultimedia-extras = %{epoch}:%{version}}
%define _with_musicbrainz --with-musicbrainz
%define _with_libsamplerate --with-libsamplerate
%define _with_taglib --with-taglib
%endif

%if "%{?nonfree}" == "1"
%define _with_akode --with-akode
BuildRequires: akode-extras
%define _with_lame --with-lame --disable-lametest
%define _with_taglib --with-taglib
%define _with_xine --with-xine
%endif

# distro/release bits
%if "%{?fedora}" > "2"
%define _with_gstreamer --with-gstreamer
%endif
%if "%{?fedora}" > "4"
%define gst gstreamer08
BuildRequires: libXxf86vm-devel
# likely only required for nonfree -- Rex
BuildRequires: libXxf86dga-devel
%endif
%if "%{?rhel}" > "3"
%define _with_gstreamer --with-gstreamer
%endif

%define is_release 2

%if "%{?core}" == "1"
Name: 	 kdemultimedia
Summary: Multimedia applications for the K Desktop Environment (KDE)
%endif
%if "%{?extras}" == "1"
Name:	 kdemultimedia-extras
Summary: Extras for KDE multimedia applications
%endif
%if "%{?nonfree}" == "1"
Name:	 kdemultimedia-extras-nonfree
Summary: Nonfree Extras for KDE multimedia applications
%endif

Group:   Applications/Multimedia
#if "%{?core}" == "1"
Epoch:	 6
#endif
Version: 3.5.3
Release: 2%{?dist}%{?kde}

License: GPL
%if "%{?patched:1}" == "1"
# From Core's kdemultimedia pkg
Source0: kdemultimedia-%{version}-patched.tar.bz2
%else
Source0: ftp://ftp.kde.org/pub/kde/stable/%{version}/src/kdemultimedia-%{version}.tar.bz2
%endif
Url:     http://multimedia.kde.org/
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: kdelibs-devel >= 6:%{version}
Requires: kdelibs >= 6:%{version}
%if "%{is_release}" != "1"
BuildRequires: automake
%endif

BuildRequires: desktop-file-utils
BuildRequires: audiofile-devel
BuildRequires: alsa-lib-devel 
BuildRequires: cdparanoia-devel cdparanoia
BuildRequires: flac-devel
BuildRequires: libtheora-devel
BuildRequires: libvorbis-devel >= 1:1.1.0
%{?core:Requires: libvorbis >= 1:1.1.0}
%{?_with_taglib:BuildRequires: taglib-devel}
%{?_with_musicbrainz:BuildRequires: libmusicbrainz-devel >= 0:2.1, libtunepimp-devel}
%{?_with_akode:BuildRequires: akode-devel}
# gstreamer(08) pkg_name
%{?_with_gstreamer:BuildRequires: %{?gst}%{!?gst:gstreamer}-plugins-devel}
%{?_with_lame:BuildRequires: lame-devel}
%{?_with_libsamplerate:BuildRequires: libsamplerate-devel}
%{?_with_xine:BuildRequires: xine-lib-devel >= 0:1.0}
## TODO (?)
#BuildRequires: gstreamer/gst, 
%{?_with_jack:BuildRequires: jack-audio-connection-kit}
%{?_with_polypaudio:BuildRequires: polypaudio-devel}

Patch0: kde-libtool.patch
Patch1: kdemultimedia-3.4.0-arts_includes.patch
Patch2: kdemultimedia-3.5.3-config.patch
Patch3: kdemultimedia-3.4.0-xdg.patch

## kde-redhat patches
# unconditinally include oggvorbis_artsplugin 
Patch1000: kdemultimedia-3.5.0-oggvorbis_artsplugin.patch
# exclude kfile_mpeg
Patch1001: kdemultimedia-3.5.2-omit_kfile_mpeg.patch
# increase buffers to minimize audio cut-outs, http://bugs.kde.org/74744
Patch74744: kdemultimedia-3.2.2-mpeglib-buffer.patch
# akode: http://bugs.kde.org/116958
Patch116958: kdemultimedia-3.5.0-116958.patch

%if "%{?core}" == "1"
%description
Multimedia applications for KDE, including:
* noatun: a multimedia player for sound and movies, very extensible due to
          it's plugin interface
* kaudiocreator: CD ripper and audio encoder frontend.
* kaboodle: light media player
* kmid: A standalone and embeddable midi player, includes a karaoke-mode
* kmidi: midi player, can use sound patch files and create a WAV file
* kmix: the audio mixer as a standalone program and Kicker applet
* kscd: A CD player with an interface to the internet CDDB database
* krec: A recording frontend using aRts

The following are libraries and plugins that are building the core
infrastructure of above applications:
* arts: a versatily multimedia system the consists of various little
        building blocks that you (or an application) can combine in
        almost arbitrary ways to create sound and video processing pipes
* kfile-plugins: provide meta information about sound files
* libkcddb: a library for retrieving and sending cddb information

%package devel
Summary: Header files, libraries for %{name}
Group:	 Development/Libraries
Requires: kdelibs-devel 
Requires: %{name} = %{epoch}:%{version}-%{release}
%description devel
%{summary}.
%endif

%if "%{?extras}" == "1"
# debugging
%{?debug:BuildConflicts: kdemultimedia-extras }
Requires: kdemultimedia >= %{epoch}:%{version}
%description 
%{summary}, including: 
* akode_artsplugin (akode)
* juk (libtunepimp)
* kfile-plugins: flac, mpc (taglib)
%endif

%if "%{?nonfree}" == "1"
Obsoletes: kdemultimedia-nonfree < %{epoch}:%{version}-%{release}
# debugging
%{?debug:BuildRequires:  kdemultimedia-extras = %{epoch}:%{version}}
%{?debug:BuildConflicts: kdemultimedia-extras-nonfree}
Requires: kdemultimedia >= %{epoch}:%{version}
# for main akode_artsplugins bits
Requires: kdemultimedia-extras >= %{epoch}:%{version}
Requires: akode-extras
%description
%{summary}, including:
* akode_artsplugin (akode-extras),
* kfile-plugins: mp3 (taglib), mpeg
* krec mp3 export (lame),
* mpeglib_artsplugin,
* xine_artsplugin (xine-lib)
%endif


%prep
%if "%{?is_release}" != "0"
%setup -q -n kdemultimedia-%{version}%{?patched}
%else
%setup -q -n kdemultimedia 
%endif

#patch0 -p1 -b .libtool
%if "%{version}" < "3.5.3"
%patch1 -p1 -b .arts_include
%endif
%patch2 -p1 -b .config
%patch3 -p1 -b .xdg

#with mpeglib in -extras, not really needed -- Rex
#patch1000   -p1 -b .oggvorbis_artsplugin
%{?nonfree:%patch74744  -p1 -b .74744}
%patch116958 -p1 -b .116958

%if "%{is_release}" != "1"
  make -f admin/Makefile.common cvs
%endif


%build
unset QTDIR || : ; . /etc/profile.d/qt.sh

DO_NOT_COMPILE=""
#{!?extras:export  DO_NOT_COMPILE="$DO_NOT_COMPILE juk"}
#{!?extras:export  DO_NOT_COMPILE="$DO_NOT_COMPILE akode_artsplugin"}
#{!?nonfree:export DO_NOT_COMPILE="$DO_NOT_COMPILE akode_artsplugin"}
#{!?nonfree:export DO_NOT_COMPILE="$DO_NOT_COMPILE xine_artsplugin"}
%{!?nonfree:export DO_NOT_COMPILE="$DO_NOT_COMPILE mpeglib mpeglib_artsplug"}
%{!?nonfree:export DO_NOT_COMPILE="$DO_NOT_COMPILE mpg123_artsplugin"}

%{?extras:export CPPFLAGS="$CPPFLAGS -I%{_includedir}/kde/arts"}

%configure \
  --includedir=%{_includedir}/kde \
  --disable-rpath \
  --disable-gcc-hidden-visibility \
  --enable-new-ldflags \
  --disable-debug --disable-warnings \
  --disable-dependancy-tracking --enable-final \
  --without-libltdl \
  --with-alsa --with-arts-alsa \
  --with-audiofile \
  --with-cdparanoia --with-extra-includes="%{_includedir}/cdda" \
  --with-flac  \
  --with-theora \
  --with-vorbis \
  %{?_with_akode} %{!?_with_akode:--without-akode} \
  %{?_with_gstreamer} %{!?_with_gstreamer:--without-gstreamer} \
  %{?_with_jack} %{!?_with_jack:--without-jack} \
  %{?_with_lame} %{!?_with_lame:--without-lame} \
  %{?_with_libsamplerate} %{!?_with_libsamplerate:--without-libsamplerate} \
  %{?_with_musicbrainz} %{!?_with_musicbrainz:--without-musicbrainz} \
  %{?_with_polypaudio} %{!?_with_polypaudio:--without-polypaudio} \
  %{?_with_taglib} %{!?_with_taglib:--without-taglib} \
  %{?_with_xine} %{!?_with_xine:--without-xine}

%if "%{?core}" == "1"
make %{?_smp_mflags} 
%endif

%if "%{?extras}" == "1"
for module in arts akode_artsplugin juk kfile-plugins/flac kfile-plugins/mpc ; do
make %{?_smp_mflags} -C $module
done
%endif

%if "%{?nonfree}" == "1"
for module in arts akode_artsplugin kfile-plugins/mp3 kfile-plugins/mpeg krec krec/mp3_export mpeglib mpeglib_artsplug xine_artsplugin ; do
make %{?_smp_mflags} -C $module
done
%endif


%install
rm -rf $RPM_BUILD_ROOT

%if "%{?core}" == "1"
make install%{!?debug_package:-strip} DESTDIR=$RPM_BUILD_ROOT
%endif

%if "%{?extras}" == "1"
for module in akode_artsplugin juk kfile-plugins/flac kfile-plugins/mpc ; do
make install%{!?debug_package:-strip} DESTDIR=$RPM_BUILD_ROOT -C $module
done

#if "%{?juk:1}" == "1"
desktop-file-install --vendor="fedora" \
  --delete-original \
  --dir $RPM_BUILD_ROOT%{_datadir}/applications/kde \
  --add-category="X-Fedora" \
  $RPM_BUILD_ROOT%{_datadir}/applications/kde/juk.desktop
#endif

%if "%{?debug}" == "1"
# Conflicts check (debuging only)
find $RPM_BUILD_ROOT -type f -o -type l | sed -e "s|$RPM_BUILD_ROOT||" | while read FILE
do
  if [ -f ${FILE} -o -L ${FILE} ]; then
    echo "WARNING: $FILE conflicts (already installed)" # && rm -f $RPM_BUILD_ROOT${FILE}
  fi
done
%endif
# file list (naive)
find $RPM_BUILD_ROOT -type f -o -type l | sed -e "s|$RPM_BUILD_ROOT||" | grep -v '.debug$' > extras.list
%endif

%if "%{?nonfree}" == "1"
for module in akode_artsplugin kfile-plugins/mp3 kfile-plugins/mpeg krec/mp3_export mpeglib mpeglib_artsplug xine_artsplugin ; do
make install%{!?debug_package:-strip} DESTDIR=$RPM_BUILD_ROOT -C $module
done
## Remove/unstinstall (conflicting) bits we don't want
# -extras bits
rm -f $RPM_BUILD_ROOT%{_libdir}/mcop/akodearts.mcop{class,type}
rm -f $RPM_BUILD_ROOT%{_libdir}/mcop/akode{,MPC,SpeexStream,VorbisStream,Xiph}PlayObject.mcopclass
rm -f $RPM_BUILD_ROOT%{_libdir}/libarts_akode.{la,so}
%if "%{?debug}" == "1"
# Conflicts check (debuging only)
find $RPM_BUILD_ROOT -type f -o -type l| sed -e "s|$RPM_BUILD_ROOT||" | while read FILE 
do
  if [ -f ${FILE} -o -L ${FILE} ]; then
    echo "WARNING: $FILE conflicts (already installed)" # && rm -f $RPM_BUILD_ROOT${FILE}
  fi
done
%endif
## (regen) file list (naive)
find $RPM_BUILD_ROOT -type f -o -type l| sed -e "s|$RPM_BUILD_ROOT||" | grep -v '.debug$' | grep -v "%{_includedir}" > nonfree.list
%endif

## File lists
# locale's
%find_lang %{name} || touch %{name}.lang
# HTML (1.0)
HTML_DIR=$(kde-config --expandvars --install html)
if [ -d $RPM_BUILD_ROOT$HTML_DIR ]; then
for lang_dir in $RPM_BUILD_ROOT$HTML_DIR/* ; do
  if [ -d $lang_dir ]; then
    lang=$(basename $lang_dir)
    echo "%lang($lang) $HTML_DIR/$lang/*" >> %{name}.lang
    # replace absolute symlinks with relative ones
    pushd $lang_dir
      for i in *; do
        [ -d $i -a -L $i/common ] && ln -nsf ../common $i/common
      done
    popd
  fi 
done  
fi

mv %{name}.lang %{name}.list

[ ! -f %{name}.list ] && echo "%defattr(-,root,root)" > %{name}.list
[ ! -f devel.list ]  && echo "%defattr(-,root,root)" > devel.list

## cleanup .la files (178734)
# if built without --without-libltdl: /usr/lib/libltdl.la 
sed -i -e "s@%{_libdir}/libltdl.la@@g" $RPM_BUILD_ROOT%{_libdir}/lib*.la ||:
# alsa-lib/asound
sed -i -e "s@-lasound@@g" $RPM_BUILD_ROOT%{_libdir}/lib*.la ||:


%if "%{?core}" == "1"
%post
/sbin/ldconfig
for icon_theme in crystalsvg hicolor locolor ; do
  touch --no-create %{_datadir}/icons/${icon_theme} 2> /dev/null ||:
  gtk-update-icon-cache -q %{_datadir}/icons/${icon_theme} 2> /dev/null ||:
done
update-desktop-database %{_datadir}/applications > /dev/null 2>&1 || :

%postun
/sbin/ldconfig
for icon_theme in crystalsvg hicolor locolor ; do
  touch --no-create %{_datadir}/icons/${icon_theme} 2> /dev/null ||:
  gtk-update-icon-cache -q %{_datadir}/icons/${icon_theme} 2> /dev/null ||:
done
update-desktop-database %{_datadir}/applications > /dev/null 2>&1 || :
%endif

%if "%{?extras}" == "1"
#if "%{?juk:1}" == "1"
%post
for icon_theme in crystalsvg hicolor ; do
  touch --no-create %{_datadir}/icons/${icon_theme} 2> /dev/null ||:
  gtk-update-icon-cache -q %{_datadir}/icons/${icon_theme} 2> /dev/null ||:
done

%postun
for icon_theme in crystalsvg hicolor ; do
  touch --no-create %{_datadir}/icons/${icon_theme} 2> /dev/null ||:
  gtk-update-icon-cache -q %{_datadir}/icons/${icon_theme} 2> /dev/null ||:
done
#endif
%endif

%if "%{?nonfree}" == "1"
%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig
%endif


%if "%{?core}" == "1"
%files -f %{name}.list
%defattr(-,root,root,-)
%doc AUTHORS COPYING README
%{_libdir}/lib*.so*
%{_libdir}/lib*.la
%{_bindir}/*
# Own dir(s) until owned by kdelibs? -- Rex
%{_sysconfdir}/xdg/menus/applications-merged/
%{_datadir}/desktop-directories/
%{_datadir}/apps/*
%{_datadir}/autostart/*.desktop
%config %{_datadir}/config*/*
%{_datadir}/icons/crystalsvg/*/*/*
%{_datadir}/icons/hicolor/*/*/*
%{_datadir}/icons/locolor/*/*/*
%{_datadir}/mimelnk/*
%{_datadir}/service*/*
%{_datadir}/appl*/*/*
%{_libdir}/mcop/*
%{_libdir}/kde3/*

%files devel -f devel.list
%defattr(-,root,root,-)
%{_includedir}/*
%endif

%if "%{?extras}" == "1"
%files -f extras.list
%defattr(-,root,root,-)
%doc AUTHORS COPYING README
%dir %{_datadir}/apps/juk/
%endif

%if "%{?nonfree}" == "1"
%files -f nonfree.list
%defattr(-,root,root,-)
%doc AUTHORS COPYING README
%dir %{_datadir}/apps/videothumbnail/
## FIXME? -- Rex
%{_includedir}/kde/mpeglib/
%{_includedir}/kde/mpeglib_artsplug/
%endif



%clean
rm -rf $RPM_BUILD_ROOT


%changelog
* Fri Jun 02 2006 Rex Dieter 6:3.5.3-2
- use -patched source
- borrow fc's -config.patch

* Wed May 24 2006 Rex Dieter 6:3.5.3-1
- kde-3.5.3

* Fri May 05 2006 Rex Dieter 6:3.5.2-5
- relax Requires: kdemultimedia

* Fri May 05 2006 Rex Dieter 6:3.5.2-4
- respin 3.5.2 for Extras

* Sun Apr 02 2006 Rex Dieter 6:3.5.2-3
- omit kfile_mpeg from (core) kdemultimedia (-> kdemultimedia-extras-nonfree)

* Tue Mar 28 2006 Rex Dieter 6:3.5.2-2
- -extras-nonfree: (fix) Obsoletes: kdemultimedia-nonfree

* Mon Mar 20 2006 Rex Dieter 6:3.5.2-1
- 3.5.2

* Fri Mar 17 2006 Rex Dieter 6:3.5.1-10
- fc5: BR: libXxf86vm-devel

* Fri Mar 17 2006 Rex Dieter 6:3.5.1-9
- fc5: BR: libXxf86dga-devel

* Fri Mar 17 2006 Rex Dieter 6:3.5.1-8
- -extras-nonfree: rename -nonfree -> -extras-nonfree
- -extras-nonfree: drop 0.lvn from Release

* Thu Mar 16 2006 Rex Dieter 6:3.5.1-7
- kfile-plugins/mp3: -extras -> -nonfree

* Thu Mar 16 2006 Rex Dieter 6:3.5.1-6
- -core/-extras: use (fc's) kdemultimedia-3.5.1-patched.tar.bz2

* Sun Feb 26 2006 Rex Dieter 6:3.5.1-5
- remove stray 'done'
- set QTLIB/QTINC (at least until #169132 is backported to fc4)

* Sat Feb 25 2006 Rex Dieter 6:3.5.1-4
- -extras: --vendor="fedora" 

* Fri Feb 24 2006 Rex Dieter 6:3.5.1-3
- -extras: --add-category="X-Fedora"

* Sun Feb 05 2006 Rex Dieter 6:3.5.1-2
- fc5+: BR: gstreamer08-plugins-devel

* Mon Jan 23 2006 Rex Dieter 6:3.5.1-1.1
- document "cleanup .la files" (#178734) 
- (re)enable juk

* Sat Jan 21 2006 Rex Dieter 6:3.5.1-1.0
- kde-3.5.1

* Fri Dec 23 2005 Rex Dieter 6:3.5.0-5
- disable juk (for now)

* Wed Dec 21 2005 Rex Dieter 6:3.5.0-4
- disable debugging/filelist-conflicts-check crud (for now)

* Wed Dec 21 2005 Rex Dieter 6:3.5.0-3
- Source: redownload, fix URL
- %%doc: AUTHORS COPYING README
- -extras: drop Obsoletes: juk

* Tue Dec 20 2005 Rex Dieter 6:3.5.0-2
- cleanup for Extras/Livna

* Fri Dec 09 2005 Rex Dieter 6:3.5.0-1.7
- --enable-new-ldflags

* Tue Nov 29 2005 Rex Dieter 6:3.5.0-1.6
- add/use %%post/%%postun for extras/nonfree
- TODO/FIXME: -nonfree includes -devel bits (mpeglib)

* Sun Nov 27 2005 Rex Dieter 6:3.5.0-1.5
- respin

* Fri Nov 25 2005 Rex Dieter 6:3.5.0-1.4
- -extras,-nonfree: include symlinks too

* Thu Nov 24 2005 Rex Dieter 6:3.5.0-1.3
- -extras,-nonfree bits (ugh)

* Wed Nov 23 2005 Rex Dieter 6:3.5.0-1.2
- -akode patch
- drop .la file stripper

* Tue Nov 22 2005 Rex Dieter 6:3.5.0-1.1
- --with-akode

* Mon Nov 21 2005 Rex Dieter 6:3.5.0-1.0
- kde-3.5.0

* Thu Nov 17 2005 Rex Dieter 6:3.5.0-0.2.rc1.kde
- (re)build against libtunepimp-0.4 (kde bug #116575)

* Sat Nov 12 2005 Rex Dieter 6:3.5.0-0.1.rc1.kde
- kde-3.5.0-rc1

* Fri Aug 12 2005 Rex Dieter 6:3.4.2-1.2.kde
- respin

* Thu Jul 21 2005 Rex Dieter 6:3.4.2-1.0.kde
- kde-3.4.2

* Mon Jun 20 2005 Rex Dieter 6:3.4.1-1.2.kde
- disable -fvisibility, for now (kde bug #101542)

* Tue May 24 2005 Rex Dieter 6:3.4.1-1.0.kde
- 3.4.1

* Fri Apr 29 2005 Rex Dieter 6:3.4.0-2.2.kde
- Ob/Pr: kdemultimedia-extras

* Wed Apr 20 2005 Rex Dieter 6:3.4.0-2.1.kde
- patch for slow kaudiocreator (kde bug #98477)

* Tue Mar 29 2005 Rex Dieter 6:3.4.0-2.0.kde
- remove libltdl.la reference(s) from .la files
- make all(most?) configure options explicit

* Wed Mar 23 2005 Rex Dieter 6:3.4.0-1.2.kde
- %%post/%%postun workarounds for recent /sbin/ldconfig (fc3/el4)

* Sat Mar 12 2005 Rex Dieter 6:3.4.0-1.1.kde
- enumerate via --with/--without exactly what is(should!) and isn't
  supported

* Fri Mar 05 2005 Rex Dieter 6:3.4.0-1.0.kde
- 3.4.0(final)

* Thu Mar 03 2005 Rex Dieter 6:3.4.0-0.1.rc1.kde
- 3.4.0

* Tue Feb 21 2005 Rex Dieter 6:3.3.92-0.3.kde
- (try to) fix artsd crasher

* Tue Feb 15 2005 Rex Dieter 6:3.3.92-0.2.kde
- 3.3.92

* Mon Nov 29 2004 Rex Dieter <rexdieter[AT]users.sf.net> 3.3.2-1.0.kde
- 3.2.2

* Thu Nov 11 2004 Rex Dieter <rexdieter[AT]users.sf.net> 3.3.1-1.0.kde
- fc3

* Tue Oct 05 2004 Rex Dieter <rexdieter at sf.net> 3.3.1-0.0.kde
- 3.3.1

* Wed Sep 29 2004 Rex Dieter <rexdieter at sf.net> 3.3.0-1.2.kde
- BR: libtunepimp-devel (musicbrainz support for juk)

* Wed Sep 08 2004 Rex Dieter <rexdieter at sf.net> 3.3.0-1.1.kde
- include better/cleaner vorbis patch

* Mon Aug 16 2004 Rex Dieter <rexdieter at sf.net> 3.3.0-1.0.kde
- 3.3.0
- fix build (libvorbisenc linking) on rh90/el3 (kde bug #88106)

